#include "cube.h"

#include <math.h>

dynent *newdynent()
{
    dynent *d = (dynent *)alloc(sizeof(dynent));
    d->x = 128;
    d->y = 128;
    d->z = 5;
    d->yaw = 270;
    d->pitch = 0;
    d->roll = 0;
    d->maxspeed = 30;
    d->outsidemap = false;
    return d;
};

dynent *player1 = newdynent();

float mousesens = 10;
int move = 0, strafe = 0;
int lastmillis = 0;

float rad(float x) { return x*3.14159f/180; };

void updateworld(int millis)
{
    if(lastmillis)
    {
        int time = millis - lastmillis;

        float tmove = (move*time*player1->maxspeed)/1000.0f;
        float tstrafe = (strafe*time*player1->maxspeed)/1000.0f;

        player1->x += (float)(tmove*cos(rad(player1->yaw-90))*cos(rad(player1->pitch)));
        player1->y += (float)(tmove*sin(rad(player1->yaw-90))*cos(rad(player1->pitch)));
        player1->x += (float)(tstrafe*cos(rad(player1->yaw-180)));
        player1->y += (float)(tstrafe*sin(rad(player1->yaw-180)));
        player1->z += (float)(tmove*sin(rad(player1->pitch)));

        if(player1->x < 0 || player1->x >= size || player1->y <0 || player1->y > size)
        {
            player1->outsidemap = true;
        }
        else
        {
            sqr *s = S((int)player1->x, (int)player1->y);
            player1->outsidemap = SOLID(s) || player1->z > s->ceil || player1->z < s->floor;
        };
    };

    lastmillis = millis;
};

void mousemove(int dx, int dy)
{
    player1->yaw += (dx/40.0f)*mousesens;
    player1->pitch -= (dy/40.0f)*mousesens;
    if(player1->pitch>90.0) player1->pitch = 90.0;
    if(player1->pitch<-90.0) player1->pitch = -90.0;
    while(player1->yaw<0.0) player1->yaw += 360.0;
    while(player1->yaw>=360.0) player1->yaw -= 360.0;
};

void mouseclick(int isdown, int butnum)
{
    if(editmode && butnum==1)
    {
        editdrag(isdown!=0);
    };
};
