// Don's gl_text.cpp

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include "cube.h"

int char_coords[256][4] = 
{
	{   1,   0,  10,  25 }, // space
	{  16,   0,  18,  25 }, // !
	{  19,   0,  25,  25 }, // "
	{  26,   0,  38,  25 }, // #
	{  39,   0,  48,  25 }, // $
	{  49,   0,  66,  25 }, // %
	{  67,   0,  80,  25 }, // &
	{  81,   0,  83,  25 }, // '
	{  85,   0,  90,  25 }, // (
	{  91,   0,  96,  25 }, // )
	{  97,   0, 105,  25 }, // *
	{ 106,   0, 116,  25 }, // +
	{ 117,   0, 119,  25 }, // ,
	{ 120,   0, 126,  25 }, // -
	{ 127,   0, 129,  25 }, // .
	{ 130,   0, 136,  25 }, // /

	{ 137,   0, 147,  25 }, // 0
	{ 148,   0, 154,  25 }, // 1
	{ 155,   0, 165,  25 }, // 2
	{ 166,   0, 176,  25 }, // 3
	{ 177,   0, 187,  25 }, // 4
	{ 188,   0, 198,  25 }, // 5
	{ 199,   0, 209,  25 }, // 6
	{ 210,   0, 220,  25 }, // 7
	{ 221,   0, 231,  25 }, // 8
	{ 232,   0, 242,  25 }, // 9
	{ 243,   0, 245,  25 }, // :
	{ 246,   0, 248,  25 }, // ;
	{   1,  25,  11,  50 }, // <
	{  12,  25,  22,  50 }, // =
	{  23,  25,  33,  50 }, // >
	{  34,  25,  44,  50 }, // ?

	{  45,  25,  64,  50 }, // @
	{  65,  25,  78,  50 }, // A
	{  79,  25,  90,  50 }, // B
	{  91,  25, 104,  50 }, // C
	{ 105,  25, 117,  50 }, // D
	{ 118,  25, 129,  50 }, // E
	{ 130,  25, 140,  50 }, // F
	{ 141,  25, 155,  50 }, // G
	{ 156,  25, 168,  50 }, // H
	{ 169,  25, 171,  50 }, // I
	{ 172,  25, 180,  50 }, // J
	{ 181,  25, 193,  50 }, // K
	{ 194,  25, 203,  50 }, // L
	{ 204,  25, 219,  50 }, // M
	{ 220,  25, 232,  50 }, // N
	{ 233,  25, 247,  50 }, // O

	{   1,  50,  12,  75 }, // P
	{  13,  50,  27,  75 }, // Q
	{  28,  50,  40,  75 }, // R
	{  41,  50,  53,  75 }, // S
	{  54,  50,  66,  75 }, // T
	{  67,  50,  79,  75 }, // U
	{  80,  50,  93,  75 }, // V
	{  94,  50, 115,  75 }, // W
	{ 116,  50, 130,  75 }, // X
	{ 131,  50, 145,  75 }, // Y
	{ 146,  50, 158,  75 }, // Z
	{ 159,  50, 163,  75 }, // [
	{ 164,  50, 170,  75 }, // '\' 
	{ 171,  50, 175,  75 }, // ]
	{ 176,  50, 184,  75 }, // ^
	{ 185,  50, 197,  75 }, // _

	{ 198,  50, 201,  75 }, // `
	{ 202,  50, 212,  75 }, // a
	{ 213,  50, 222,  75 }, // b
	{ 223,  50, 232,  75 }, // c
	{ 233,  50, 242,  75 }, // d
	{ 243,  50, 253,  75 }, // e
	{   1,  75,   8, 100 }, // f
	{   9,  75,  18, 100 }, // g
	{  19,  75,  28, 100 }, // h
	{  29,  75,  31, 100 }, // i
	{  32,  75,  36, 100 }, // j
	{  37,  75,  46, 100 }, // k
	{  47,  75,  49, 100 }, // l
	{  50,  75,  64, 100 }, // m
	{  65,  75,  74, 100 }, // n
	{  75,  75,  85, 100 }, // o

	{  86,  75,  95, 100 }, // p
	{  96,  75, 105, 100 }, // q
	{ 106,  75, 112, 100 }, // r
	{ 113,  75, 122, 100 }, // s
	{ 123,  75, 128, 100 }, // t
	{ 129,  75, 138, 100 }, // u
	{ 139,  75, 152, 100 }, // v
	{ 153,  75, 170, 100 }, // w
	{ 171,  75, 181, 100 }, // x
	{ 182,  75, 192, 100 }, // y
	{ 193,  75, 203, 100 }, // z
	{ 204,  75, 210, 100 }, // {
	{ 211,  75, 213, 100 }, // |
	{ 214,  75, 220, 100 }, // }
	{ 221,  75, 231, 100 }, // ~
	{ 232,  75, 243, 100 }, // 0x7f
};

void draw_text(char *fstr, int left, int top, int gl_num, int arg1, int arg2)
{
    char str[256];
    sprintf(str,fstr,arg1,arg2);

	glBlendFunc(GL_ONE, GL_ONE);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, gl_num);

	double x = (double) left;
	double y = (double) top;

	int i;
	double in_left, in_top, in_right, in_bottom, in_width, in_height;
	char c;

	for (i = 0; str[i] != 0; i++)
	{
		c = str[i]-32;
        if(c<0 || c>=96) c = 0;

		in_left    = ((double) char_coords[c][0]) / 256.0;
		in_top     = ((double) char_coords[c][1]) / 256.0;
		in_right   = ((double) char_coords[c][2]) / 256.0;
		in_bottom  = ((double) char_coords[c][3]) / 256.0;

		in_width   = (double) char_coords[c][2] - char_coords[c][0];
		in_height  = (double) char_coords[c][3] - char_coords[c][1];

		glBegin(GL_QUADS);
		glTexCoord2d(in_left,  in_bottom); glVertex2d(x,            y + in_height);
		glTexCoord2d(in_right, in_bottom); glVertex2d(x + in_width, y + in_height);
		glTexCoord2d(in_right, in_top   ); glVertex2d(x + in_width, y);
		glTexCoord2d(in_left,  in_top   ); glVertex2d(x,            y);
		glEnd();

		x += in_width  + 1;
	}

	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
}
